create
    definer = `youon-vrt20`@`%` procedure SP_BIZ_FREEBIE(IN _id_plan int, IN _country_iso char(2),
                                                         IN _email varchar(255), IN _domain varchar(255),
                                                         IN _id_user bigint, OUT _result int,
                                                         OUT _description varchar(255), OUT _id_freebies text,
                                                         OUT _freebie_codes text)
BEGIN

DECLARE no_more_rows INT DEFAULT FALSE;
DECLARE num_rows INT DEFAULT 0;
DECLARE c_id_freebie INT;
DECLARE _return_code INT;
DECLARE _totalWhiteListActive INT UNSIGNED;

DECLARE _totalUsedbyUser INT UNSIGNED;
DECLARE _applied_to_all_periods INT UNSIGNED;
DECLARE _billing_period INT UNSIGNED;
DECLARE _one_use_per_user INT UNSIGNED;

DECLARE cursor_freebie CURSOR FOR SELECT id_freebie FROM freebies WHERE id_freebie in (SELECT id_freebie FROM freebies_plans_related WHERE id_plan = _id_plan) AND 
			active = 1 AND (begin_date <= now() AND (date(end_date) = '0000-00-00' OR end_date >= now()));
DECLARE CONTINUE HANDLER FOR NOT FOUND SET no_more_rows = TRUE;


DECLARE exit handler for sqlexception
  BEGIN
    
		SELECT -1,'' into _result, _description;
    rollback;
  END;




DROP TEMPORARY TABLE IF EXISTS biz_tmp_c;
CREATE TEMPORARY TABLE IF NOT EXISTS biz_tmp_c SELECT 0 as return_code,'-------------------------------------------------------------------' as description,100 as position,0 as id_freebie,0 as id_code;

 
   
    OPEN cursor_freebie;

    SELECT FOUND_ROWS() into num_rows;
    
      read_loop: LOOP
        FETCH cursor_freebie INTO c_id_freebie;
    
        IF no_more_rows THEN
          LEAVE read_loop;
        END IF;
      
	
	


   
    INSERT into biz_tmp_c VALUES (0,'------------------------------',100,c_id_freebie,0);
    
SELECT count(1) into _totalUsedbyUser FROM freebies_used WHERE claimed_by_user = _id_user AND id_freebie = c_id_freebie;

SELECT applied_to_all_periods,billing_period,one_use_per_user into _applied_to_all_periods,_billing_period,_one_use_per_user 
FROM freebies p WHERE id_freebie = c_id_freebie; 



IF(_one_use_per_user = 1 AND _totalUsedbyUser > 0)
THEN
	INSERT into biz_tmp_c VALUES (-40,'already claimed by user',1,c_id_freebie,0);
END IF;



IF EXISTS (SELECT id_freebie FROM freebies_security_countries WHERE id_freebie = c_id_freebie)
THEN

	IF EXISTS (SELECT id_security FROM freebies_security_countries WHERE exclude = 1 AND id_freebie = c_id_freebie)
	THEN
		IF EXISTS (SELECT id_security FROM freebies_security_countries WHERE country_iso = _country_iso AND exclude = 1 AND id_freebie = c_id_freebie)
		THEN
			INSERT into biz_tmp_c VALUES (-50,CONCAT('not valid for this country: ',FN_GET_COUNTRY(_country_iso)),2,c_id_freebie,0);
		END IF;

	ELSE
		IF NOT EXISTS (SELECT id_security FROM freebies_security_countries WHERE country_iso = _country_iso AND exclude = 0 AND id_freebie = c_id_freebie)
		THEN
			INSERT into biz_tmp_c VALUES (-50,CONCAT('not valid for this country: ',FN_GET_COUNTRY(_country_iso)),2,c_id_freebie,0);
		END IF;
    
    END IF;
    
END IF;


SELECT count(1) into _totalWhiteListActive FROM freebies_whitelist_related WHERE active = 1 AND id_freebie = c_id_freebie;

IF(_totalWhiteListActive > 0)
THEN

	 SELECT count(1) into @totalEmail FROM promotions_whitelist_related WHERE type = 1 AND value =  _email AND id_freebie = c_id_freebie AND active = 1;
	 SELECT count(1) into @totalDomain FROM promotions_whitelist_related WHERE type = 2 AND value =  _domain AND id_freebie = c_id_freebie AND active = 1;
	 
	IF((SELECT @totalEmail+@totalDomain) < 1)
	THEN
		INSERT into biz_tmp_c VALUES (-60,'not in whitelist',1,c_id_freebie,0);
	END IF;

END IF;


              
	SELECT count(1) into @totalTemp FROM biz_tmp_c WHERE id_freebie = c_id_freebie;
	IF(@totalTemp < 2)
	THEN
		IF(_one_use_per_user = 1)
        THEN
			INSERT into biz_tmp_c 
			SELECT 0,'',0,id_freebie,id_code FROM freebies_codes_related fcr 
			WHERE active = 1 
			AND (unlimited = 1 OR ((quantity-(SELECT count(1) FROM freebies_used WHERE id_code = fcr.id_code) > 0)))
			AND id_code not in (SELECT id_code FROM freebies_used WHERE claimed_by_user = _id_user) AND id_freebie = c_id_freebie ORDER by rand() LIMIT 0,1;
        ELSE
			INSERT into biz_tmp_c 
			SELECT 0,'',0,id_freebie,id_code FROM freebies_codes_related fcr 
			WHERE active = 1 
			AND (unlimited = 1 OR ((quantity-(SELECT count(1) FROM freebies_used WHERE id_code = fcr.id_code) > 0)))
			AND id_freebie = c_id_freebie ORDER by rand() LIMIT 0,1;
        END IF;
	END IF;            
              
    
	
    
      END LOOP read_loop;

    CLOSE cursor_freebie;
    

SELECT GROUP_CONCAT(id_code SEPARATOR ',') into _freebie_codes FROM
(SELECT id_code FROM  biz_tmp_c) as tt;
SELECT GROUP_CONCAT(id_freebie SEPARATOR ',') into _id_freebies FROM
(SELECT id_freebie FROM  biz_tmp_c) as tt;

    SELECT return_code, description,_id_freebies,_freebie_codes into _result, _description,_id_freebies,_freebie_codes FROM biz_tmp_c ORDER BY position ASC LIMIT 0,1;
    
   



END;

