create
    definer = `youon-vrt14`@`%` procedure SP_BIZ_PROMOTION(IN _id_plan int, IN _country_iso char(2),
                                                           IN _email varchar(255), IN _domain varchar(255),
                                                           OUT _result int, OUT _description varchar(255),
                                                           OUT _id_promotion int)
BEGIN

DECLARE no_more_rows INT DEFAULT FALSE;
DECLARE num_rows INT DEFAULT 0;
DECLARE c_id_promotion INT;
DECLARE _return_code INT;
DECLARE _totalWhiteListActive INT UNSIGNED;

DECLARE cursor_promotion CURSOR FOR SELECT id_promotion FROM promotions WHERE id_promotion in (SELECT id_promotion FROM promotions_plans_related WHERE id_plan = _id_plan) AND 
			code_required = 0 and active = 1 AND (begin_date <= now() AND (date(end_date) = '0000-00-00' OR end_date >= now()));
DECLARE CONTINUE HANDLER FOR NOT FOUND SET no_more_rows = TRUE;


DECLARE exit handler for sqlexception
  BEGIN
    
		SELECT -1,'' into _result, _description;
    rollback;
  END;




DROP TEMPORARY TABLE IF EXISTS biz_tmp_c;
CREATE TEMPORARY TABLE IF NOT EXISTS biz_tmp_c SELECT 0 as return_code,'-------------------------------------------------------------------' as description,100 as position,0 as id_promotion;

 
   
    OPEN cursor_promotion;

    SELECT FOUND_ROWS() into num_rows;
    
      read_loop: LOOP
        FETCH cursor_promotion INTO c_id_promotion;
    
        IF no_more_rows THEN
          LEAVE read_loop;
        END IF;
      
	
	


    truncate table biz_tmp_c;
    INSERT into biz_tmp_c VALUES (0,'------------------------------',100,c_id_promotion);

IF EXISTS (SELECT id_promotion FROM promotions_security_countries WHERE id_promotion = c_id_promotion)
THEN

	IF EXISTS (SELECT id_security FROM promotions_security_countries WHERE exclude = 1 AND id_promotion = c_id_promotion)
	THEN
		IF EXISTS (SELECT id_security FROM promotions_security_countries WHERE country_iso = _country_iso AND exclude = 1 AND id_promotion = c_id_promotion)
		THEN
			INSERT into biz_tmp_c VALUES (-50,CONCAT('not valid for this country: ',FN_GET_COUNTRY(_country_iso)),2,c_id_promotion);
		END IF;

	ELSE
		IF NOT EXISTS (SELECT id_security FROM promotions_security_countries WHERE country_iso = _country_iso AND exclude = 0 AND id_promotion = c_id_promotion)
		THEN
			INSERT into biz_tmp_c VALUES (-50,CONCAT('not valid for this country: ',FN_GET_COUNTRY(_country_iso)),2,c_id_promotion);
		END IF;
    
    END IF;
    
END IF;


SELECT count(1) into _totalWhiteListActive FROM promotions_whitelist_related WHERE active = 1 AND id_promotion = c_id_promotion;

IF(_totalWhiteListActive > 0)
THEN

	 SELECT count(1) into @totalEmail FROM promotions_whitelist_related WHERE type = 1 AND value =  _email AND id_promotion = c_id_promotion AND active = 1;
	 SELECT count(1) into @totalDomain FROM promotions_whitelist_related WHERE type = 2 AND value =  _domain AND id_promotion = c_id_promotion AND active = 1;
	 
	IF((SELECT @totalEmail+@totalDomain) < 1)
	THEN
		INSERT into biz_tmp_c VALUES (-60,'not in whitelist',1,c_id_promotion);
	END IF;

END IF;


              
              
              
	SELECT count(1) into @totalTemp FROM biz_tmp_c;
	IF(@totalTemp < 2)
	THEN
		LEAVE read_loop;
	END IF;            
              
    
	
    
      END LOOP read_loop;

    CLOSE cursor_promotion;
    

    SELECT return_code, description,id_promotion into _result, _description,_id_promotion FROM biz_tmp_c ORDER BY position ASC LIMIT 0,1;
    
   



END;

