create
    definer = `youon-vrt14`@`%` procedure SP_BIZ_PROMOTION_WITH_CODE(IN _code varchar(255), IN _id_plan int(10),
                                                                     IN _country_iso char(2), IN _id_user bigint,
                                                                     OUT _result int, OUT _description varchar(255),
                                                                     OUT _promotionID int)
BEGIN

DECLARE _quantity INT UNSIGNED;
DECLARE _unlimited INT UNSIGNED;
DECLARE _code_active INT UNSIGNED;
DECLARE _id_code INT UNSIGNED;
DECLARE _id_promotion INT UNSIGNED;

DECLARE _plan_active INT UNSIGNED;
DECLARE _plan_allow_promotions INT UNSIGNED;

DECLARE _totalWhiteListActive INT UNSIGNED;
DECLARE _totalUsed INT UNSIGNED;
DECLARE _totalUsedbyUser INT UNSIGNED;
DECLARE _totalTempClaimed INT UNSIGNED;
DECLARE _timeDiffTempClaimed INT UNSIGNED;
DECLARE _claimedByUserTempClaimed INT UNSIGNED;

DECLARE _promotion_type INT UNSIGNED;
DECLARE _percent_off FLOAT(10,2);
DECLARE _price_off FLOAT(10,2);
DECLARE _begin_date DATETIME;
DECLARE _end_date DATETIME;
DECLARE _applied_on_renewal INT UNSIGNED;
DECLARE _applied_to_all_periods INT UNSIGNED;
DECLARE _billing_period INT UNSIGNED;
DECLARE _promotion_active INT UNSIGNED;

DECLARE _promotion_code_required INT UNSIGNED;

DECLARE _email VARCHAR(255);
DECLARE _domain VARCHAR(255);


DECLARE exit handler for sqlexception
  BEGIN
    
	SET _result = -1; 
    SET _description = 'error';
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_code FROM promotions_codes_related WHERE code = _code) AND EXISTS (SELECT id_plan FROM plans WHERE id_plan = _id_plan)
THEN

SELECT id_code,id_promotion,quantity,unlimited,active into _id_code,_id_promotion,_quantity,_unlimited,_code_active FROM promotions_codes_related WHERE code = _code;
SELECT count(1) into _totalUsed FROM promotions_used WHERE id_code = _id_code;
SELECT active,allow_promotions into _plan_active,_plan_allow_promotions FROM plans WHERE id_plan = _id_plan;

SELECT count(1) into _totalUsedbyUser FROM promotions_used WHERE claimed_by_user = _id_user;
SELECT email,SUBSTRING_INDEX(email,'@',-1) into _email,_domain FROM users WHERE id_user = _id_user;
SELECT count(1),TIME_TO_SEC(TIMEDIFF(now(),claimed_date)),claimed_by_user into _totalTempClaimed,_timeDiffTempClaimed,_claimedByUserTempClaimed FROM promotions_codes_temporary_claimed WHERE id_code = _id_code;

SELECT promotion_type,percent_off,price_off,begin_date,end_date,applied_on_renewal,applied_to_all_periods,billing_period,active,code_required 
into _promotion_type,_percent_off,_price_off,_begin_date,_end_date,_applied_on_renewal,_applied_to_all_periods,_billing_period,_promotion_active,_promotion_code_required FROM promotions p WHERE id_promotion = _id_promotion;

DROP TEMPORARY TABLE IF EXISTS biz_tmp;
CREATE TEMPORARY TABLE IF NOT EXISTS biz_tmp SELECT 0 as return_code,'-------------------------------------------------------------------' as description,100 as position,_id_promotion as id_promotion;


IF(_code_active = 0)
THEN
		INSERT into biz_tmp VALUES (-51,'code not active',1,_id_promotion);
END IF;

IF(_promotion_active = 0)
THEN
		INSERT into biz_tmp VALUES (-51,'promotion not active',1,_id_promotion);
END IF;



IF EXISTS (SELECT id_promotion FROM promotions_security_countries WHERE id_promotion = _id_promotion)
THEN

	IF EXISTS (SELECT id_security FROM promotions_security_countries WHERE exclude = 1 AND id_promotion = _id_promotion)
	THEN
		IF EXISTS (SELECT id_security FROM promotions_security_countries WHERE country_iso = _country_iso AND exclude = 1 AND id_promotion = _id_promotion)
		THEN
			INSERT into biz_tmp VALUES (-50,CONCAT('not valid for this country: ',FN_GET_COUNTRY(_country_iso)),2,_id_promotion);
		END IF;

	ELSE
		IF NOT EXISTS (SELECT id_security FROM promotions_security_countries WHERE country_iso = _country_iso AND exclude = 0 AND id_promotion = _id_promotion)
		THEN
			INSERT into biz_tmp VALUES (-50,CONCAT('not valid for this country: ',FN_GET_COUNTRY(_country_iso)),2,_id_promotion);
		END IF;
    
    END IF;
    
END IF;


IF (_plan_active = 1)
THEN
	IF (_plan_allow_promotions = 1)
	THEN
		IF NOT EXISTS (SELECT id_promotion FROM promotions_plans_related WHERE id_promotion = _id_promotion)
		THEN
			INSERT into biz_tmp VALUES (-54,'not valid for this plan',3,_id_promotion);
		END IF;
    ELSE
			INSERT into biz_tmp VALUES (-54,'not valid for this plan',4,_id_promotion);
	END IF;
ELSE
			INSERT into biz_tmp VALUES (-54,'not valid for this plan',5,_id_promotion);
END IF;



IF (_end_date <= now() AND _end_date <> '0000-00-00 00:00:00')
THEN
			INSERT into biz_tmp VALUES (-52,'not valid anymore',7,_id_promotion);
END IF;

IF (_begin_date > now())
THEN
	INSERT into biz_tmp VALUES (-53,'not valid yet',8,_id_promotion);
END IF;



IF (_unlimited = 0 AND _quantity <= _totalUsed)
THEN
		INSERT into biz_tmp VALUES (-51,'sold out',9,_id_promotion);
END IF;

IF(_unlimited = 0 AND (_quantity-_totalUsed) = 1)
THEN
	IF(_totalTempClaimed > 0 AND _claimedByUserTempClaimed <> _id_user AND _timeDiffTempClaimed < 1800)
	THEN
		INSERT into biz_tmp VALUES (-55,'code temporary sold out',10,_id_promotion);
	END IF;
END IF;



SELECT count(1) into _totalWhiteListActive FROM promotions_whitelist_related WHERE active = 1 AND id_promotion = _id_promotion;

IF(_totalWhiteListActive > 0)
THEN

 SELECT count(1) into @totalEmail FROM promotions_whitelist_related WHERE type = 1 AND value =  _email AND id_promotion = _id_promotion AND active = 1;
 SELECT count(1) into @totalDomain FROM promotions_whitelist_related WHERE type = 2 AND value =  _domain AND id_promotion = _id_promotion AND active = 1;
	 
	IF((SELECT @totalEmail+@totalDomain) < 1)
	THEN
		INSERT into biz_tmp VALUES (-60,'not in whitelist',1,_id_promotion);
	END IF;
    
END IF;





	IF(_totalTempClaimed > 0 AND _timeDiffTempClaimed > 1800)
	THEN
		DELETE FROM promotions_codes_temporary_claimed WHERE id_code = _id_code;
	END IF;



SELECT count(1) into @totalTemp FROM biz_tmp;
IF(@totalTemp < 2)
THEN

	IF(_unlimited = 0 AND (_quantity-_totalUsed) = 1)
	THEN
		INSERT into promotions_codes_temporary_claimed(id_code,claimed_by_user,claimed_date,register_date) VALUES(_id_code,_id_user,now(),now()) ON DUPLICATE KEY UPDATE update_date = now(),claimed_by_user = _id_user,claimed_date = now();
	END IF;

	SELECT 0,'',_id_promotion into _result,_description,_promotionID;
    
ELSE    
    SELECT return_code, description,id_promotion into _result,_description,_promotionID FROM biz_tmp ORDER BY position ASC LIMIT 0,1;
END IF;



ELSE
	SET _result = -2; 
    SET _description = 'code not exist';    
END IF;
        
COMMIT;

END;

