create
    definer = `youon-vrt14`@`%` procedure SP_GET_BIZ_PROMOTION_VALIDATE_CODE(IN _code varchar(255), IN _id_plan int(10),
                                                                             IN _country_iso char(2),
                                                                             IN _id_user bigint)
BEGIN

DECLARE _quantity INT UNSIGNED;
DECLARE _unlimited INT UNSIGNED;
DECLARE _code_active INT UNSIGNED;
DECLARE _id_code INT UNSIGNED;
DECLARE _id_promotion INT UNSIGNED;

DECLARE _plan_active INT UNSIGNED;
DECLARE _plan_allow_promotions INT UNSIGNED;

DECLARE _totalUsed INT UNSIGNED;
DECLARE _totalUsedbyUser INT UNSIGNED;
DECLARE _totalTempClaimed INT UNSIGNED;
DECLARE _timeDiffTempClaimed INT UNSIGNED;
DECLARE _claimedByUserTempClaimed INT UNSIGNED;

DECLARE _promotion_type INT UNSIGNED;
DECLARE _percent_off FLOAT(10,2);
DECLARE _price_off FLOAT(10,2);
DECLARE _begin_date DATETIME;
DECLARE _end_date DATETIME;
DECLARE _applied_on_renewal INT UNSIGNED;
DECLARE _applied_to_all_periods INT UNSIGNED;
DECLARE _billing_period INT UNSIGNED;
DECLARE _promotion_active INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_code FROM promotions_codes_related WHERE code = _code) AND EXISTS (SELECT id_plan FROM plans WHERE id_plan = _id_plan)
THEN

SELECT id_code,id_promotion,quantity,unlimited,active into _id_code,_id_promotion,_quantity,_unlimited,_code_active FROM promotions_codes_related WHERE code = _code;
SELECT count(1) into _totalUsed FROM promotions_used WHERE id_code = _id_code;
SELECT active,allow_promotions into _plan_active,_plan_allow_promotions FROM plans WHERE id_plan = _id_plan;

SELECT count(1) into _totalUsedbyUser FROM promotions_used WHERE claimed_by_user = _id_user;
SELECT count(1),TIME_TO_SEC(TIMEDIFF(now(),claimed_date)),claimed_by_user into _totalTempClaimed,_timeDiffTempClaimed,_claimedByUserTempClaimed FROM promotions_codes_temporary_claimed WHERE id_code = _id_code;

SELECT promotion_type,percent_off,price_off,begin_date,end_date,applied_on_renewal,applied_to_all_periods,billing_period,active 
into _promotion_type,_percent_off,_price_off,_begin_date,_end_date,_applied_on_renewal,_applied_to_all_periods,_billing_period,_promotion_active FROM promotions p WHERE id_promotion = _id_promotion;

DROP TEMPORARY TABLE IF EXISTS biz_tmp;
CREATE TEMPORARY TABLE IF NOT EXISTS biz_tmp SELECT 0 as return_code,'------------------------------' as description,100 as position;


IF(_code_active = 0)
THEN
		INSERT into biz_tmp VALUES (-51,'Code not active',1);
END IF;



IF EXISTS (SELECT id_promotion FROM promotions_security_countries WHERE id_promotion = _id_promotion)
THEN

	IF EXISTS (SELECT id_security FROM promotions_security_countries WHERE exclude = 1 AND id_promotion = _id_promotion)
	THEN
		IF EXISTS (SELECT id_security FROM promotions_security_countries WHERE country_iso = _country_iso AND exclude = 1 AND id_promotion = _id_promotion)
		THEN
			INSERT into biz_tmp VALUES (-50,'Not valid for this country',2);
		END IF;

	ELSE
		IF NOT EXISTS (SELECT id_security FROM promotions_security_countries WHERE country_iso = _country_iso AND exclude = 0 AND id_promotion = _id_promotion)
		THEN
			INSERT into biz_tmp VALUES (-50,'Not valid for this country',2);
		END IF;
    
    END IF;
    
END IF;


IF (_plan_active = 1)
THEN
	IF (_plan_allow_promotions = 1)
	THEN
		IF NOT EXISTS (SELECT id_promotion FROM promotions_plans_related WHERE id_promotion = _id_promotion)
		THEN
			INSERT into biz_tmp VALUES (-54,'Not valid for this plan',3);
		END IF;
    ELSE
			INSERT into biz_tmp VALUES (-54,'Not valid for this plan',4);
	END IF;
ELSE
			INSERT into biz_tmp VALUES (-54,'Not valid for this plan',5);
END IF;



IF (_end_date <= now() AND _end_date <> '0000-00-00 00:00:00')
THEN
			INSERT into biz_tmp VALUES (-52,'Not valid anymore',7);
END IF;

IF (_begin_date > now())
THEN
	INSERT into biz_tmp VALUES (-53,'Not valid yet',8);
END IF;



IF (_unlimited = 0 AND _quantity <= _totalUsed)
THEN
		INSERT into biz_tmp VALUES (-51,'Sold out',9);
END IF;

IF(_unlimited = 0 AND (_quantity-_totalUsed) = 1)
THEN
	IF(_totalTempClaimed > 0 AND _claimedByUserTempClaimed <> _id_user AND _timeDiffTempClaimed < 1800)
	THEN
		INSERT into biz_tmp VALUES (-55,'Code temporary sold out',10);
	END IF;
END IF;





	IF(_totalTempClaimed > 0 AND _timeDiffTempClaimed > 1800)
	THEN
		DELETE FROM promotions_codes_temporary_claimed WHERE id_code = _id_code;
	END IF;



SELECT count(1) into @totalTemp FROM biz_tmp;
IF(@totalTemp < 2)
THEN

	IF(_unlimited = 0 AND (_quantity-_totalUsed) = 1)
	THEN
		INSERT into promotions_codes_temporary_claimed(id_code,claimed_by_user,claimed_date,register_date) VALUES(_id_code,_id_user,now(),now()) ON DUPLICATE KEY UPDATE update_date = now(),claimed_by_user = _id_user,claimed_date = now();
	END IF;

	SELECT id_promotion,promotion_type,percent_off,price_off,applied_on_renewal,applied_to_all_periods,billing_period FROM promotions p WHERE id_promotion = _id_promotion;
    
ELSE    
    SELECT return_code, description FROM biz_tmp ORDER BY position ASC LIMIT 0,1;
END IF;



ELSE
    SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

