create
    definer = `youon-vrt14`@`%` procedure SP_GET_PUBLISH_OTT(IN _limit_a int(10), IN _limit_b int(10))
BEGIN

DECLARE _last_publish DATETIME;
DECLARE t1_a text;
DECLARE t1_b text;
DECLARE t1_c text;

DECLARE sqlcommand text;

DECLARE sqlcommand_stmt_new text;
DECLARE sqlcommand_create text;
DECLARE sqlcommand_new_plans text;
DECLARE sqlcommand_new_plans_sets text;

DECLARE sqlcommand_stmt_delete text;
DECLARE sqlcommand_delete text;
DECLARE sqlcommand_delete_plans text;
DECLARE sqlcommand_delete_plans_sets text;

DECLARE sqlcommand_stmt_update text;
DECLARE sqlcommand_update text;
DECLARE sqlcommand_update_plans text;
DECLARE sqlcommand_update_plans_sets text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(SELECT count(1) FROM ott_publish_log WHERE date(end_publish_date) <> '0000-00-00')
THEN
	SELECT end_publish_date into _last_publish FROM ott_publish_log WHERE date(end_publish_date) <> '0000-00-00' ORDER by id_publish desc LIMIT 0,1;
ELSE
	SET _last_publish = '0000-00-00 00:00:00';
END IF;

SET @_last_publish = _last_publish;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;


DROP TEMPORARY TABLE IF EXISTS ott_publish_tmp_create;

SET t1_a = "CREATE TEMPORARY TABLE IF NOT EXISTS ott_publish_tmp_create ";



SET sqlcommand_new_plans = "SELECT 1 as type,1 as action_type,id_plan as id, update_date, register_date FROM plans WHERE id_plan in (SELECT id_plan FROM plans_sets_plans_related) AND register_date > @_last_publish" ;
SET sqlcommand_new_plans_sets = "SELECT 2 as type,1 as action_type,id_plan_set as id, update_date, register_date FROM plans_sets WHERE register_date > @_last_publish";

SET sqlcommand_create = CONCAT(sqlcommand_new_plans," UNION ",sqlcommand_new_plans_sets);

SET @sqlcommand_stmt_new = CONCAT(t1_a,sqlcommand_create);

PREPARE stmt_create FROM @sqlcommand_stmt_new;
EXECUTE stmt_create;




 DROP TEMPORARY TABLE IF EXISTS ott_publish_tmp_update;
SET t1_c = "CREATE TEMPORARY TABLE IF NOT EXISTS ott_publish_tmp_update ";

SET sqlcommand_update_plans = "SELECT 1 as type,action_type,p.id_plan as id, p.update_date, p.register_date FROM plans p, ott_sync_updated psy WHERE psy.id_plan = p.id_plan";
SET sqlcommand_update_plans_sets = "SELECT 2 as type,action_type,c.id_plan_set as id, c.update_date, c.register_date FROM plans_sets c, ott_sync_updated psy WHERE psy.id_plan_set = c.id_plan_set";

SET sqlcommand_update = CONCAT(sqlcommand_update_plans," UNION ",sqlcommand_update_plans_sets);

SET @sqlcommand_stmt_update = CONCAT(t1_c,sqlcommand_update);

PREPARE stmt_update FROM @sqlcommand_stmt_update;
EXECUTE stmt_update;




DROP TEMPORARY TABLE IF EXISTS ott_publish_tmp_delete;
SET t1_b = "CREATE TEMPORARY TABLE IF NOT EXISTS ott_publish_tmp_delete ";

SET sqlcommand_delete_plans = "SELECT 1 as type,3 as action_type,id_plan as id,'' as update_date,register_date FROM ott_sync_deleted WHERE register_date > @_last_publish AND id_plan > 0 AND last_sync_date = '0000-00-00 00:00:00'";
SET sqlcommand_delete_plans_sets = "SELECT 2 as type,3 as action_type,id_plan_set as id,'' as update_date,register_date FROM ott_sync_deleted WHERE register_date > @_last_publish AND id_plan_set > 0 AND last_sync_date = '0000-00-00 00:00:00'";

SET sqlcommand_delete = CONCAT(sqlcommand_delete_plans," UNION ",sqlcommand_delete_plans_sets);

SET @sqlcommand_stmt_delete = CONCAT(t1_b,sqlcommand_delete);

PREPARE stmt_delete FROM @sqlcommand_stmt_delete;
EXECUTE stmt_delete;

SELECT count(1) into @total FROM(
SELECT * FROM ott_publish_tmp_create 
 UNION
 SELECT * FROM ott_publish_tmp_delete 
 UNION
 SELECT * FROM ott_publish_tmp_update
) as tt;

SET sqlcommand ="
SELECT *,@total as total FROM(
SELECT * FROM ott_publish_tmp_create 
UNION
SELECT * FROM ott_publish_tmp_delete 
UNION
SELECT * FROM ott_publish_tmp_update) as tt LIMIT ?,?";

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;

COMMIT;

END;

