<?php namespace Skoiy\Ott\Promotion;

use DateTime;
use Stage\Helper;
use Exception;

class Used
{
    const ID = 1;

    /**
     * @var
     */
    private $id = -1;
    private $idCode;
    private $code;
    private $idPromotion;
    private $idPlan;
    private $plan;
    private $claimedByUser;
    private $claimedEmail;
    private $claimedDate;

    /**
     * @var
     */
    private $updateDate;

    /**
     * @var
     */
    private $registerDate;

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = array('');

    /**
     * The attributes that should be visible in arrays.
     *
     * @var array
     */
    protected $visible = array();

    /**
     * The model's attributes.
     *
     * @var array
     */
    protected $attributes = array('id', 'idCode', 'idPromotion', 'code', 'idPlan', 'plan', 'claimedByUser', 'claimedEmail', 'claimedDate', 'updateDate', 'registerDate');

    /**
     * The attributes that aren't mass assignable.
     *
     * @var array
     */
    protected $guarded = array('id');    // The attributes that cannot be setted on the model

    public function __construct()
    {
    }

    public function getId()
    {
        return $this->id;
    }

    public function getIdCode()
    {
        return $this->id;
    }

    public function getIdPromotion()
    {
        return $this->idPromotion;
    }

    public function getCode()
    {
        return $this->code;
    }

    public function getIdPlan()
    {
        return $this->idPromotion;
    }

    public function getPlan()
    {
        return $this->idPromotion;
    }

    public function getClaimedByUser()
    {
        return $this->claimedByUser;
    }

    public function getClaimedEmail()
    {
        return $this->claimedEmail;
    }

    public function getClaimedDate()
    {
        return $this->claimedDate;
    }

    public function getUpdateDate()
    {
        return $this->updateDate;
    }

    public function getRegisterDate()
    {
        return $this->registerDate;
    }

    public function setId($id_promotion)
    {
        $this->id = $id_promotion;
    }

    public function setIdCode($id)
    {
        $this->idCode = $id;
    }

    public function setIdPromotion($id_promotion)
    {
        $this->idPromotion = $id_promotion;
    }

    public function setCode($code)
    {
        $this->code = $code;
    }

    public function setIdPlan($idPlan)
    {
        $this->idPlan = $idPlan;
    }

    public function setPlan($plan)
    {
        $this->plan = $plan;
    }

    public function setClaimedByUser($user)
    {
        $this->claimedByUser = $user;
    }

    public function setClaimedEmail($email)
    {
        $this->claimedEmail = $email;
    }

    public function setClaimedDate($date)
    {
        $this->claimedDate = $date;
    }

    /**
     * @param mixed $updateDate
     */
    public function setUpdateDate($updateDate)
    {
        $this->updateDate = $updateDate;
    }

    /**
     * @param mixed $registerDate
     */
    public function setRegisterDate($registerDate)
    {
        $this->registerDate = $registerDate;
    }

    /**
     * Convert the model instance to JSON.
     *
     * @param int $options
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Convert the model instance to an array.
     *
     * @return array
     */
    public function toArray()
    {
        $attributes = $this->attributesToArray();

        return $attributes;
    }

    /**
     * Convert the model's attributes to an array.
     *
     * @return array
     */
    public function attributesToArray()
    {
        $attributes = $this->getArrayableAttributes();
        $arr = array();

        foreach ($attributes as $attribute) {
            if ($attribute == "registerDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else if ($attribute == "updateDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else if ($attribute == "claimedEmail" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else {
                $arr[$attribute] = $attribute == "name" || $attribute == "nameStripped" ? html_entity_decode($this->$attribute, ENT_COMPAT, 'UTF-8') : $this->$attribute;
            }
        }

        return $arr;
    }

    /**
     * Get an attribute array of all arrayable attributes.
     *
     * @return array
     */
    protected function getArrayableAttributes()
    {
        return $this->getArrayableItems($this->attributes);
    }

    /**
     * Get an attribute array of all arrayable values.
     *
     * @param array $values
     * @return array
     */
    protected function getArrayableItems(array $values)
    {
        if (count($this->visible) > 0) {
            return array_intersect_key($values, array_flip($this->visible));
        }

        return array_flip(array_diff_key(array_flip($values), array_flip($this->hidden)));
    }

    /**
     * @param $asset
     * @return Used
     * @throws Exception
     */
    public static function createInstance($asset)
    {
        if (isset($asset[0]) && isset($asset[0]['id_code']))
            $asset = $asset[0];

        $instance = new self();
        $instance->setId($asset['id']);
        $instance->setIdCode($asset['id_code']);
        $instance->setCode($asset['code']);
        $instance->setIdPromotion($asset['id_promotion']);
        $instance->setIdPlan($asset['id_plan']);
        $instance->setPlan($asset['plan']);
        $instance->setClaimedByUser($asset['claimed_by_user']);
        $instance->setClaimedEmail($asset['claimed_email']);

        if (isset($asset['claimed_date']) && Helper::isValidDate($asset['claimed_date'], "Y-m-d H:i:s")) {
            $instance->setClaimedDate(new DateTime($asset['claimed_date']));
        }

        if (isset($asset['update_date']) && Helper::isValidDate($asset['update_date'], "Y-m-d H:i:s")) {
            $instance->setUpdateDate(new DateTime($asset['update_date']));
        }

        if (isset($asset['register_date']) && Helper::isValidDate($asset['register_date'], "Y-m-d H:i:s")) {
            $instance->setRegisterDate(new DateTime($asset['register_date']));
        }

        return $instance;
    }

    public function __toString()
    {
        return "My id is: {$this->getId()}\n";
    }

}