<?php namespace Skoiy\Ott\User;

use DateTime;
use Stage\Helper;

class PlanQueryResponse
{
    /**
     * @var
     */
    private $id = -1;

    /**
     * @var
     */
    private $active;

    /**
     * @var
     */
    private $idTransaction;

    /**
     * @var
     */
    private $name;

    /**
     * @var
     */
    private $endDate;

    /**
     * @var
     */
    private $planType;

    /**
     * @var
     */
    private $planTypeDescription;

    /**
     * @var
     */
    private $updateDate;

    /**
     * @var
     */
    private $registerDate;

    /**
     * The model's attributes.
     *
     * @var array
     */
    protected $attributes = array('id', 'active', 'idTransaction', 'name', 'endDate', 'planType', 'planTypeDescription', 'updateDate', 'registerDate');

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = array('');

    /**
     * The attributes that should be visible in arrays.
     *
     * @var array
     */
    protected $visible = array();

    /**
     * The attributes that aren't mass assignable.
     *
     * @var array
     */
    protected $guarded = array('id');    // The attributes that cannot be setted on the model

    public function __construct()
    {
    }

    public function getId()
    {
        return $this->id;
    }

    /**
     * @return mixed
     */
    public function getActive()
    {
        return $this->active;
    }

    /**
     * @return mixed
     */
    public function getIdTransaction()
    {
        return $this->idTransaction;
    }

    /**
     * @return mixed
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * @return mixed
     */
    public function getEndDate()
    {
        return $this->endDate;
    }

    /**
     * @return mixed
     */
    public function getPlanType()
    {
        return $this->planType;
    }

    /**
     * @return mixed
     */
    public function getPlanTypeDescription()
    {
        return $this->planTypeDescription;
    }

    /**
     * @return mixed
     */
    public function getUpdateDate()
    {
        return $this->updateDate;
    }

    /**
     * @return mixed
     */
    public function getRegisterDate()
    {
        return $this->registerDate;
    }

    /**
     * @param mixed $idUser
     */
    public function setId($idUser)
    {
        $this->id = (int)$idUser;
    }

    /**
     * @param mixed $id
     */
    public function setIdTransaction($id)
    {
        $this->idTransaction = (int)$id;
    }


    /**
     * @param mixed $active
     */
    public function setIsActive($active)
    {
        $this->active = (bool)$active;
    }

    public function setName($name)
    {
        $this->name = $name;
    }

    /**
     * @param mixed $date
     */
    public function setEndDate($date)
    {
        $this->endDate = $date;
    }

    /**
     * @param mixed $type
     */
    public function setPlanType($type)
    {
        $this->planType = $type;
    }

    /**
     * @param mixed $desc
     */
    public function setPlanTypeDescription($desc)
    {
        $this->planTypeDescription = $desc;
    }

    /**
     * @param mixed $updateDate
     */
    public function setUpdateDate($updateDate)
    {
        $this->updateDate = $updateDate;
    }

    /**
     * @param mixed $registerDate
     */
    public function setRegisterDate($registerDate)
    {
        $this->registerDate = $registerDate;
    }

    /**
     * Convert the model instance to JSON.
     *
     * @param int $options
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Convert the model instance to an array.
     *
     * @return array
     */
    public function toArray()
    {
        $attributes = $this->attributesToArray();

        return $attributes;
    }

    /**
     * Convert the model's attributes to an array.
     *
     * @return array
     */
    public function attributesToArray()
    {
        $attributes = $this->getArrayableAttributes();
        $arr = array();

        foreach ($attributes as $attribute) {
            if ($attribute == "registerDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else if ($attribute == "updateDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else if ($attribute == "lastLogin" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else {
                $arr[$attribute] = $attribute == "name" || $attribute == "getPlanTypeDescription" || $attribute == "imageTitle" || $attribute == "imageAlterText" || $attribute == "plan" ? html_entity_decode($this->$attribute, ENT_COMPAT, 'UTF-8') : $this->$attribute;
            }
        }

        return $arr;
    }

    /**
     * Get an attribute array of all arrayable attributes.
     *
     * @return array
     */
    protected function getArrayableAttributes()
    {
        return $this->getArrayableItems($this->attributes);
    }

    /**
     * Get an attribute array of all arrayable values.
     *
     * @param array $values
     * @return array
     */
    protected function getArrayableItems(array $values)
    {
        if (count($this->visible) > 0) {
            return array_intersect_key($values, array_flip($this->visible));
        }

        return array_flip(array_diff_key(array_flip($values), array_flip($this->hidden)));
    }

    /**
     * createInstance
     *
     * @param $asset
     */
    public static function createInstance($asset)
    {
        $instance = new self();
        $instance->setId($asset['id_plan']);
        $instance->setIsActive($asset['active']);
        $instance->setIdTransaction($asset['id_transaction']);
        $instance->setName(html_entity_decode($asset['name'], ENT_COMPAT, 'UTF-8'));
        $instance->setEndDate($asset['end_date']);
        $instance->setPlanType($asset['plan_type']);
        $instance->setPlanTypeDescription(html_entity_decode($asset['plan_type_description'], ENT_COMPAT, 'UTF-8'));

        if (isset($asset['update_date']) && Helper::isValidDate($asset['update_date'], "Y-m-d H:i:s")) {
            $instance->setUpdateDate(new DateTime($asset['update_date']));
        }

        if (isset($asset['register_date']) && Helper::isValidDate($asset['register_date'], "Y-m-d H:i:s")) {
            $instance->setRegisterDate(new DateTime($asset['register_date']));
        }

        return $instance;
    }

    public function __toString()
    {
        return "My id is: {$this->getId()}\n";
    }

}