<?php namespace Skoiy\Ott\User;

use PDO;
use Stage\Stage;
use DateTime;
use Stage\Helper;
use Exception;

class User
{
    const ID = 1;

    /**
     * @var
     */
    private $id = -1;

    /**
     * @var
     */
    private $idPlan;

    /**
     * @var
     */
    private $plan;

    /**
     * @var
     */
    private $planStripped;

    /**
     * @var
     */
    private $totalProfiles;

    /**
     * @var
     */
    private $name = "";

    /**
     * @var
     */
    private $email;

    /**
     * @var
     */
    private $gender;

    /**
     * @var
     */
    private $birthdate;

    /**
     * @var
     */
    private $identification;

    /**
     * @var
     */
    private $taxNumber;

    /**
     * @var
     */
    private $nationality;

    /**
     * @var
     */
    private $countryIso;

    /**
     * @var
     */
    private $city;

    /**
     * @var
     */
    private $address;

    /**
     * @var
     */
    private $zipcode;

    /**
     * @var
     */
    private $phone;

    /**
     * @var
     */
    private $active;

    /**
     * @var
     */
    private $verified;

    /**
     * @var
     */
    private $lastActivity;

    /**
     * @var
     */
    private $lastLogin;

    /**
     * @var
     */
    private $updateDate;

    /**
     * @var
     */
    private $registerDate;

    /**
     * The model's attributes.
     *
     * @var array
     */
    protected $attributes = array('id', 'idPlan', 'plan', 'planStripped', 'totalProfiles', 'name', 'email', 'gender', 'birthdate', 'identification', 'taxNumber', 'nationality', 'countryIso', 'city', 'address', 'zipcode', 'phone', 'active', 'verified', 'lastActivity', 'lastLogin', 'updateDate', 'registerDate');

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = array('');

    /**
     * The attributes that should be visible in arrays.
     *
     * @var array
     */
    protected $visible = array();

    /**
     * The attributes that aren't mass assignable.
     *
     * @var array
     */
    protected $guarded = array('id');    // The attributes that cannot be setted on the model

    public function __construct()
    {
    }

    public function getId()
    {
        return $this->id;
    }

    /**
     * @return mixed
     */
    public function getIdPlan()
    {
        return $this->idPlan;
    }

    /**
     * @return mixed
     */
    public function getPlan()
    {
        return $this->plan;
    }

    /**
     * @return mixed
     */
    public function getPlanStripped()
    {
        return $this->planStripped;
    }

    /**
     * @return mixed
     */
    public function getTotalProfiles()
    {
        return $this->totalProfiles;
    }

    /**
     * @return mixed
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * @return mixed
     */
    public function getEmail()
    {
        return $this->email;
    }

    /**
     * @return mixed
     */
    public function getGender()
    {
        return $this->gender;
    }

    /**
     * @return mixed
     */
    public function getBirthdate()
    {
        return $this->birthdate;
    }

    /**
     * @return mixed
     */
    public function getIdentification()
    {
        return $this->identification;
    }

    /**
     * @return mixed
     */
    public function getTaxNumber()
    {
        return $this->taxNumber;
    }

    /**
     * @return mixed
     */
    public function getNationality()
    {
        return $this->nationality;
    }

    /**
     * @return mixed
     */
    public function getCountryIso()
    {
        return $this->countryIso;
    }

    /**
     * @return mixed
     */
    public function getCity()
    {
        return $this->city;
    }

    /**
     * @return mixed
     */
    public function getAddress()
    {
        return $this->address;
    }

    /**
     * @return mixed
     */
    public function getZipcode()
    {
        return $this->zipcode;
    }

    /**
     * @return mixed
     */
    public function getPhone()
    {
        return $this->phone;
    }

    /**
     * @return mixed
     */
    public function getActive()
    {
        return $this->active;
    }

    /**
     * @return mixed
     */
    public function getVerified()
    {
        return $this->verified;
    }

    /**
     * @return mixed
     */
    public function getLastActivity()
    {
        return $this->lastActivity;
    }

    /**
     * @return mixed
     */
    public function getLastLogin()
    {
        return $this->lastLogin;
    }

    /**
     * @return mixed
     */
    public function getUpdateDate()
    {
        return $this->updateDate;
    }

    /**
     * @return mixed
     */
    public function getRegisterDate()
    {
        return $this->registerDate;
    }

    /**
     * @param mixed $idUser
     */
    public function setId($idUser)
    {
        $this->id = (int)$idUser;
    }

    /**
     * @param mixed $idPlan
     */
    public function setIdPlan($idPlan)
    {
        $this->idPlan = (int)$idPlan;
    }

    /**
     * @param mixed $plan
     */
    public function setPlan($plan)
    {
        $this->plan = $plan;
    }

    /**
     * @param mixed $planStripped
     */
    public function setPlanStripped($planStripped)
    {
        $this->planStripped = $planStripped;
    }

    public function setTotalProfiles($total)
    {
        $this->totalProfiles = $total;
    }

    /**
     * @param mixed $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }

    /**
     * @param mixed $email
     */
    public function setEmail($email)
    {
        $this->email = $email;
    }

    /**
     * @param mixed $gender
     */
    public function setGender($gender)
    {
        $this->gender = $gender;
    }

    /**
     * @param mixed $birthdate
     */
    public function setBirthdate($birthdate)
    {
        $this->birthdate = $birthdate;
    }

    /**
     * @param mixed $identification
     */
    public function setIdentification($identification)
    {
        $this->identification = $identification;
    }

    /**
     * @param mixed $taxNumber
     */
    public function setTaxNumber($taxNumber)
    {
        $this->taxNumber = $taxNumber;
    }

    /**
     * @param mixed $nationality
     */
    public function setNationality($nationality)
    {
        $this->nationality = $nationality;
    }

    /**
     * @param mixed $countryIso
     */
    public function setCountryIso($countryIso)
    {
        $this->countryIso = $countryIso;
    }

    /**
     * @param mixed $city
     */
    public function setCity($city)
    {
        $this->city = $city;
    }

    /**
     * @param mixed $address
     */
    public function setAddress($address)
    {
        $this->address = $address;
    }

    /**
     * @param mixed $zipcode
     */
    public function setZipcode($zipcode)
    {
        $this->zipcode = $zipcode;
    }

    /**
     * @param mixed $phone
     */
    public function setPhone($phone)
    {
        $this->phone = $phone;
    }

    /**
     * @param mixed $active
     */
    public function setActive($active)
    {
        $this->active = (bool)$active;
    }

    /**
     * @param mixed $verified
     */
    public function setVerified($verified)
    {
        $this->verified = (bool)$verified;
    }

    /**
     * @param mixed $verified
     */
    public function setLastActivity($activity)
    {
        $this->lastActivity = $activity;
    }

    /**
     * @param mixed $lastLogin
     */
    public function setLastLogin($lastLogin)
    {
        $this->lastLogin = $lastLogin;
    }

    /**
     * @param mixed $updateDate
     */
    public function setUpdateDate($updateDate)
    {
        $this->updateDate = $updateDate;
    }

    /**
     * @param mixed $registerDate
     */
    public function setRegisterDate($registerDate)
    {
        $this->registerDate = $registerDate;
    }

    /**
     * @return array
     * @throws Exception
     */
    public static function sizeof()
    {
        $name = "OTT_USERS_NUM";
        $method = "GET";
        $parameters = [];
        $data = Stage::esp($parameters, $name, $method);
        return $data;
    }

    /**
     * @param $idUser
     * @return User
     * @throws Exception
     */
    public static function find($idUser)
    {
        try {
            $name = "OTT_USER";
            $method = "GET";
            $parameters = [[$idUser, PDO::PARAM_INT]];

            $data = Stage::esp($parameters, $name, $method);

            if (isset($data[0]['return_code']) && $data[0]['return_code'] == "-2") {
                throw new Exception("The User id $idUser not exists.", $data[0]['return_code']);
            } else {
                return self::createInstance($data[0]);
            }
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * @param Query $q
     * @return array|User[]
     * @throws Exception
     */
    public static function query(Query $q)
    {
        $field = $q->by;
        $sndField = $q->sndBy;
        $trdField = $q->trdBy;
        $sndFilter = $q->sndFilter;
        $trdFilter = $q->trdFilter;
        $term = $q->term;
        $filter = $q->filter;
        $from = $q->from;
        $to = $q->to;
        $orderBy = $q->orderBy;
        $order = $q->order;

        try {
            $parameters = [[$field, PDO::PARAM_INT],
                [$sndField, PDO::PARAM_INT],
                [$trdField, PDO::PARAM_INT],
                [$term, PDO::PARAM_STR],
                [$filter, PDO::PARAM_STR],
                [$sndFilter, PDO::PARAM_STR],
                [$trdFilter, PDO::PARAM_STR],
                [$orderBy, PDO::PARAM_INT],
                [$order, PDO::PARAM_INT],
                [$from, PDO::PARAM_INT],
                [$to, PDO::PARAM_INT],];

            $name = "OTT_USERS";
            $method = "GET";
            $data = Stage::esp($parameters, $name, $method);
            return array_map(function ($user) {
                return self::createInstance($user);
            }, $data);
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * @param Query $q
     * @return mixed
     * @throws Exception
     */
    public static function queryCount(Query $q)
    {
        $field = $q->by;
        $sndField = $q->sndBy;
        $trdField = $q->trdBy;
        $sndFilter = $q->sndFilter;
        $trdFilter = $q->trdFilter;
        $term = $q->term;
        $filter = $q->filter;

        try {
            $parameters = [[$field, PDO::PARAM_INT],
                [$sndField, PDO::PARAM_INT],
                [$trdField, PDO::PARAM_INT],
                [$term, PDO::PARAM_STR],
                [$filter, PDO::PARAM_STR],
                [$sndFilter, PDO::PARAM_STR],
                [$trdFilter, PDO::PARAM_STR]];

            $name = "OTT_USERS_COUNT";
            $method = "GET";
            $data = Stage::esp($parameters, $name, $method);
            return $data[0]['total'];
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * @param Query $q
     * @return array|User[]
     * @throws Exception
     */
    public static function queryPlans(Query $q)
    {
        $idUser = $q->idUser;
        $field = $q->by;
        $sndField = $q->sndBy;
        $trdField = $q->trdBy;
        $sndFilter = $q->sndFilter;
        $trdFilter = $q->trdFilter;
        $term = $q->term;
        $filter = $q->filter;
        $from = $q->from;
        $to = $q->to;
        $orderBy = $q->orderBy;
        $order = $q->order;

        try {
            $parameters = [[$idUser, PDO::PARAM_INT],
                [$field, PDO::PARAM_INT],
                [$sndField, PDO::PARAM_INT],
                [$trdField, PDO::PARAM_INT],
                [$term, PDO::PARAM_STR],
                [$filter, PDO::PARAM_STR],
                [$sndFilter, PDO::PARAM_STR],
                [$trdFilter, PDO::PARAM_STR],
                [$orderBy, PDO::PARAM_INT],
                [$order, PDO::PARAM_INT],
                [$from, PDO::PARAM_INT],
                [$to, PDO::PARAM_INT],];

            $name = "OTT_USER_PLANS";
            $method = "GET";
            $data = Stage::esp($parameters, $name, $method);
            return array_map(function ($user) {
                return PlanQueryResponse::createInstance($user);
            }, $data);
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * @param Query $q
     * @return mixed
     * @throws Exception
     */
    public static function queryPlansCount(Query $q)
    {
        $idUser = $q->idUser;
        $field = $q->by;
        $sndField = $q->sndBy;
        $trdField = $q->trdBy;
        $sndFilter = $q->sndFilter;
        $trdFilter = $q->trdFilter;
        $term = $q->term;
        $filter = $q->filter;

        try {
            $parameters = [[$idUser, PDO::PARAM_INT],
                [$field, PDO::PARAM_INT],
                [$sndField, PDO::PARAM_INT],
                [$trdField, PDO::PARAM_INT],
                [$term, PDO::PARAM_STR],
                [$filter, PDO::PARAM_STR],
                [$sndFilter, PDO::PARAM_STR],
                [$trdFilter, PDO::PARAM_STR]];

            $name = "OTT_USER_PLANS_COUNT";
            $method = "GET";
            $data = Stage::esp($parameters, $name, $method);
            return $data[0]['total'];
        } catch (Exception $e) {
            throw $e;
        }
    }
    /**
     * @param Query $q
     * @return array|User[]
     * @throws Exception
     */
    public static function queryTransactions(Query $q)
    {
        $idUser = $q->idUser;
        $field = $q->by;
        $sndField = $q->sndBy;
        $trdField = $q->trdBy;
        $sndFilter = $q->sndFilter;
        $trdFilter = $q->trdFilter;
        $term = $q->term;
        $filter = $q->filter;
        $from = $q->from;
        $to = $q->to;
        $orderBy = $q->orderBy;
        $order = $q->order;

        try {
            $parameters = [[$idUser, PDO::PARAM_INT],
                [$field, PDO::PARAM_INT],
                [$sndField, PDO::PARAM_INT],
                [$trdField, PDO::PARAM_INT],
                [$term, PDO::PARAM_STR],
                [$filter, PDO::PARAM_STR],
                [$sndFilter, PDO::PARAM_STR],
                [$trdFilter, PDO::PARAM_STR],
                [$orderBy, PDO::PARAM_INT],
                [$order, PDO::PARAM_INT],
                [$from, PDO::PARAM_INT],
                [$to, PDO::PARAM_INT],];

            $name = "OTT_USER_TRANSACTIONS";
            $method = "GET";
            $data = Stage::esp($parameters, $name, $method);
            return array_map(function ($user) {
                return TransactionQueryResponse::createInstance($user);
            }, $data);
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * @param Query $q
     * @return mixed
     * @throws Exception
     */
    public static function queryTransactionsCount(Query $q)
    {
        $idUser = $q->idUser;
        $field = $q->by;
        $sndField = $q->sndBy;
        $trdField = $q->trdBy;
        $sndFilter = $q->sndFilter;
        $trdFilter = $q->trdFilter;
        $term = $q->term;
        $filter = $q->filter;

        try {
            $parameters = [[$idUser, PDO::PARAM_INT],
                [$field, PDO::PARAM_INT],
                [$sndField, PDO::PARAM_INT],
                [$trdField, PDO::PARAM_INT],
                [$term, PDO::PARAM_STR],
                [$filter, PDO::PARAM_STR],
                [$sndFilter, PDO::PARAM_STR],
                [$trdFilter, PDO::PARAM_STR]];

            $name = "OTT_USER_TRANSACTIONS_COUNT";
            $method = "GET";
            $data = Stage::esp($parameters, $name, $method);
            return $data[0]['total'];
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * @return $this
     * @throws Exception
     * @description Save on table plans_price_related
     */
    public function save()
    {
        $idUser = $this->getId();
        $name = $this->getName();
        $email = $this->getEmail();
        $gender = $this->getGender();
        $birthdate = $this->getBirthdate();
        $identification = $this->getIdentification();
        $tax_number = $this->getTaxNumber();
        $nationality = $this->getNationality();
        $city = $this->getCity();
        $address = $this->getAddress();
        $zipCode = $this->getZipcode();
        $country_iso = $this->getCountryIso();
        $phone = $this->getPhone();
        $active = $this->getActive();
        $verified = $this->getVerified();

        try {
            $parameters = [[$idUser, PDO::PARAM_INT],
                [$name, PDO::PARAM_STR],
                [$email, PDO::PARAM_STR],
                [$gender, PDO::PARAM_STR],
                [$birthdate, PDO::PARAM_STR],
                [$identification, PDO::PARAM_STR],
                [$tax_number, PDO::PARAM_STR],
                [$nationality, PDO::PARAM_STR],
                [$country_iso, PDO::PARAM_STR],
                [$address, PDO::PARAM_STR],
                [$city, PDO::PARAM_STR],
                [$zipCode, PDO::PARAM_STR],
                [$phone, PDO::PARAM_STR],
                [$active, PDO::PARAM_BOOL],
                [$verified, PDO::PARAM_BOOL]];

            $name = "OTT_USER";
            $method = "SET";
            $data = Stage::esp($parameters, $name, $method);
            if (!isset($data[0]) && !isset($data[0]['id_user'])) {
                throw new Exception("Error saving User");
            }

            $this->setId($data[0]['id_user']);
            if (isset($data[0]['update_date']) && Helper::isValidDate($data[0]['update_date'], "Y-m-d H:i:s")) {
                $this->setUpdateDate(new DateTime($data[0]['update_date']));
            }
            if (isset($data[0]['register_date']) && Helper::isValidDate($data[0]['register_date'], "Y-m-d H:i:s")) {
                $this->setRegisterDate(new DateTime($data[0]['register_date']));
            }
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * Convert the model instance to JSON.
     *
     * @param int $options
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Convert the model instance to an array.
     *
     * @return array
     */
    public function toArray()
    {
        $attributes = $this->attributesToArray();

        return $attributes;
    }

    /**
     * Convert the model's attributes to an array.
     *
     * @return array
     */
    public function attributesToArray()
    {
        $attributes = $this->getArrayableAttributes();
        $arr = array();

        foreach ($attributes as $attribute) {
            if ($attribute == "registerDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else if ($attribute == "updateDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else if ($attribute == "lastLogin" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else {
                $arr[$attribute] = $attribute == "name" || $attribute == "nameStripped" || $attribute == "imageTitle" || $attribute == "imageAlterText" || $attribute == "plan" ? html_entity_decode($this->$attribute, ENT_COMPAT, 'UTF-8') : $this->$attribute;
            }
        }

        return $arr;
    }

    /**
     * Get an attribute array of all arrayable attributes.
     *
     * @return array
     */
    protected function getArrayableAttributes()
    {
        return $this->getArrayableItems($this->attributes);
    }

    /**
     * Get an attribute array of all arrayable values.
     *
     * @param array $values
     * @return array
     */
    protected function getArrayableItems(array $values)
    {
        if (count($this->visible) > 0) {
            return array_intersect_key($values, array_flip($this->visible));
        }

        return array_flip(array_diff_key(array_flip($values), array_flip($this->hidden)));
    }

    /**
     * createInstance
     *
     * @param $asset
     */
    public static function createInstance($asset)
    {
        $instance = new self();
        $instance->setId($asset['id_user']);
        $instance->setIdPlan($asset['id_plan']);
        $instance->setPlan(html_entity_decode($asset['plan'], ENT_COMPAT, 'UTF-8'));
        $instance->setPlanStripped($asset['plan_stripped']);
        $instance->setTotalProfiles($asset['total_profiles']);
        $instance->setName(html_entity_decode($asset['name'], ENT_COMPAT, 'UTF-8'));
        $instance->setEmail($asset['email']);
        $instance->setGender($asset['gender']);
        $instance->setBirthdate($asset['birthdate']);
        $instance->setIdentification($asset['identification']);
        $instance->setTaxNumber($asset['tax_number']);
        $instance->setNationality(html_entity_decode($asset['nationality'], ENT_COMPAT, 'UTF-8'));
        $instance->setCountryIso($asset['country_iso']);
        $instance->setCity(html_entity_decode($asset['city'], ENT_COMPAT, 'UTF-8'));
        $instance->setAddress(html_entity_decode($asset['address'], ENT_COMPAT, 'UTF-8'));
        $instance->setZipcode($asset['zipcode']);
        $instance->setPhone($asset['phone']);
        $instance->setActive($asset['active']);
        $instance->setVerified($asset['verified']);
        $instance->setLastActivity($asset['last_activity']);

        if (isset($asset['last_login']) && Helper::isValidDate($asset['last_login'], "Y-m-d H:i:s")) {
            $instance->setLastLogin(new DateTime($asset['last_login']));
        }

        if (isset($asset['update_date']) && Helper::isValidDate($asset['update_date'], "Y-m-d H:i:s")) {
            $instance->setUpdateDate(new DateTime($asset['update_date']));
        }

        if (isset($asset['register_date']) && Helper::isValidDate($asset['register_date'], "Y-m-d H:i:s")) {
            $instance->setRegisterDate(new DateTime($asset['register_date']));
        }

        return $instance;
    }

    public function __toString()
    {
        return "My id is: {$this->getId()}\n";
    }

}